"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.typeRenderer = void 0;
const react_1 = __importDefault(require("react"));
const semantics_entities_semantic_schema_1 = require("@teambit/semantics.entities.semantic-schema");
const api_reference_overview_renderers_grouped_schema_nodes_overview_summary_1 = require("@teambit/api-reference.overview.renderers.grouped-schema-nodes-overview-summary");
const api_reference_renderers_api_node_details_1 = require("@teambit/api-reference.renderers.api-node-details");
exports.typeRenderer = {
    predicate: (node) => node.__schema === semantics_entities_semantic_schema_1.TypeSchema.name,
    Component: TypeComponent,
    nodeType: 'Types',
    icon: { name: 'Type', url: 'https://static.bit.dev/api-reference/type.svg' },
    default: true,
    OverviewComponent: TypeOverviewComponent,
};
function TypeComponent(props) {
    var _a, _b, _c;
    const { apiNode: { api }, renderers, metadata, } = props;
    const typeNode = api;
    const { type } = typeNode;
    const subTypeRenderer = renderers.find((renderer) => renderer.predicate(type));
    if ((_a = metadata === null || metadata === void 0 ? void 0 : metadata[api.__schema]) === null || _a === void 0 ? void 0 : _a.columnView) {
        return ((subTypeRenderer && (react_1.default.createElement(subTypeRenderer.Component, Object.assign({}, props, { apiNode: Object.assign(Object.assign({}, props.apiNode), { api: type, renderer: subTypeRenderer }), depth: ((_b = props.depth) !== null && _b !== void 0 ? _b : 0) + 1, metadata: { [type.__schema]: { columnView: true } } })))) ||
            null);
    }
    return (react_1.default.createElement(api_reference_renderers_api_node_details_1.APINodeDetails, Object.assign({}, props, { options: { hideIndex: true } }), subTypeRenderer && (react_1.default.createElement(subTypeRenderer.Component, Object.assign({}, props, { apiNode: Object.assign(Object.assign({}, props.apiNode), { api: type, renderer: subTypeRenderer }), depth: ((_c = props.depth) !== null && _c !== void 0 ? _c : 0) + 1 })))));
}
function TypeOverviewComponent(props) {
    const { apiNode: { api, renderer }, } = props;
    const typeNode = api;
    const icon = renderer === null || renderer === void 0 ? void 0 : renderer.icon;
    const { type } = typeNode;
    const nodes = type.getNodes();
    return react_1.default.createElement(api_reference_overview_renderers_grouped_schema_nodes_overview_summary_1.SchemaNodesSummary, { name: typeNode.name, nodes: nodes, icon: icon, apiNodeRendererProps: props });
}
//# sourceMappingURL=type.renderer.js.map